# cloudmersive-dataintegration-api-client

CloudmersiveDataintegrationApiClient - the Ruby gem for the dataintegrationapi

Easily and directly query database backup files, convert into other file formats.

This SDK is automatically generated by the [Swagger Codegen](https://github.com/swagger-api/swagger-codegen) project:

- API version: v1
- Package version: 2.0.2
- Build package: io.swagger.codegen.languages.RubyClientCodegen

## Installation

### Build a gem

To build the Ruby code into a gem:

```shell
gem build cloudmersive-dataintegration-api-client.gemspec
```

Then either install the gem locally:

```shell
gem install ./cloudmersive-dataintegration-api-client-2.0.2.gem
```
(for development, run `gem install --dev ./cloudmersive-dataintegration-api-client-2.0.2.gem` to install the development dependencies)

or publish the gem to a gem hosting service, e.g. [RubyGems](https://rubygems.org/).

Finally add this to the Gemfile:

    gem 'cloudmersive-dataintegration-api-client', '~> 2.0.2'

### Install from Git

If the Ruby gem is hosted at a git repository: https://github.com/GIT_USER_ID/GIT_REPO_ID, then add the following in the Gemfile:

    gem 'cloudmersive-dataintegration-api-client', :git => 'https://github.com/GIT_USER_ID/GIT_REPO_ID.git'

### Include the Ruby code directly

Include the Ruby code directly using `-I` as follows:

```shell
ruby -Ilib script.rb
```

## Getting Started

Please follow the [installation](#installation) procedure and then run the following code:
```ruby
# Load the gem
require 'cloudmersive-dataintegration-api-client'

# Setup authorization
CloudmersiveDataintegrationApiClient.configure do |config|
  # Configure API key authorization: Apikey
  config.api_key['Apikey'] = 'YOUR API KEY'
  # Uncomment the following line to set a prefix for the API key, e.g. 'Bearer' (defaults to nil)
  #config.api_key_prefix['Apikey'] = 'Bearer'
end

api_instance = CloudmersiveDataintegrationApiClient::BackupConvertApi.new

opts = { 
  input_file: File.new('/path/to/file.txt') # File | Input file to perform the operation on
}

begin
  #Lists all tables stored in a SQL Server Backup (.BAK) file
  result = api_instance.dataintegration_backup_convert_mssql_bak_get_tables_post(opts)
  p result
rescue CloudmersiveDataintegrationApiClient::ApiError => e
  puts "Exception when calling BackupConvertApi->dataintegration_backup_convert_mssql_bak_get_tables_post: #{e}"
end

```

## Documentation for API Endpoints

All URIs are relative to *https://localhost*

Class | Method | HTTP request | Description
------------ | ------------- | ------------- | -------------
*CloudmersiveDataintegrationApiClient::BackupConvertApi* | [**dataintegration_backup_convert_mssql_bak_get_tables_post**](docs/BackupConvertApi.md#dataintegration_backup_convert_mssql_bak_get_tables_post) | **POST** /dataintegration/backup/convert/mssql/bak/get/tables | Lists all tables stored in a SQL Server Backup (.BAK) file
*CloudmersiveDataintegrationApiClient::BackupConvertApi* | [**dataintegration_backup_convert_mssql_bak_to_csv_post**](docs/BackupConvertApi.md#dataintegration_backup_convert_mssql_bak_to_csv_post) | **POST** /dataintegration/backup/convert/mssql/bak/to/csv | Converts a SQL Server Backup (.BAK) file into CSV for a specified table


## Documentation for Models

 - [CloudmersiveDataintegrationApiClient::MssqlBakEnumerateTablesResult](docs/MssqlBakEnumerateTablesResult.md)
 - [CloudmersiveDataintegrationApiClient::MssqlTable](docs/MssqlTable.md)


## Documentation for Authorization


### Apikey

- **Type**: API key
- **API key parameter name**: Apikey
- **Location**: HTTP header

